package com.liang.controller;

import com.liang.common.annotation.LogAround;
import com.liang.entity.BaseCompanytype;
import com.liang.service.BaseCompanytypeService;
import io.swagger.annotations.ApiOperation;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (BaseCompanytype)表控制层
 *
 * @author makejava
 * @since 2023-03-04 11:00:03
 */
@Controller
@RequestMapping("baseCompanytype")
public class BaseCompanytypeController {
    /**
     * 服务对象
     */
    @Resource
    private BaseCompanytypeService baseCompanytypeService;

    /**
     * 分页查询
     *
     * @param baseCompanytype 筛选条件
     * @param pageRequest     分页对象
     * @return 查询结果
     */
    @GetMapping
    public ResponseEntity<Page<BaseCompanytype>> queryByPage(BaseCompanytype baseCompanytype, PageRequest pageRequest) {
        return ResponseEntity.ok(this.baseCompanytypeService.queryByPage(baseCompanytype, pageRequest));
    }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    public ResponseEntity<BaseCompanytype> queryById(@PathVariable("id") String id) {
        return ResponseEntity.ok(this.baseCompanytypeService.queryById(id));
    }

    /**
     * 新增数据
     *
     * @param baseCompanytype 实体
     * @return 新增结果
     */
    @PostMapping
    public ResponseEntity<BaseCompanytype> add(BaseCompanytype baseCompanytype) {
        return ResponseEntity.ok(this.baseCompanytypeService.insert(baseCompanytype));
    }

    /**
     * 编辑数据
     *
     * @param baseCompanytype 实体
     * @return 编辑结果
     */
    @PutMapping
    public ResponseEntity<BaseCompanytype> edit(BaseCompanytype baseCompanytype) {
        return ResponseEntity.ok(this.baseCompanytypeService.update(baseCompanytype));
    }

    /**
     * 删除数据
     *
     * @param id 主键
     * @return 删除是否成功
     */
    @DeleteMapping
    public ResponseEntity<Boolean> deleteById(String id) {
        return ResponseEntity.ok(this.baseCompanytypeService.deleteById(id));
    }

    @ApiOperation(value = "页面初始化", notes = "页面初始化")
    @RequestMapping(value = "/init", method = RequestMethod.GET)
    public String init() {
        return "basecompanytype/list";
    }

    @LogAround("数据分页查询")
    @ApiOperation(value = "数据分页查询", notes = "数据分页查询")
    @ResponseBody
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Object list() {

        List<BaseCompanytype> list = baseCompanytypeService.queryAll();

        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("code", 0);
        resultMap.put("msg", "");
        resultMap.put("count", list.size());
        resultMap.put("data", list);

        return resultMap;
    }
}

